
#include "global.h"

/******************************************************************************
 *                                                                            *
 *  Function : void nlc_one_1d()
 *                                                                            *
 ******************************************************************************/

void nlc_one_1d()
{
  int i, pn;
  int offset;
  int next[Procmax];

/******************************************************************************
 *  Function : void nlc_scan_1d()                                             *
 ******************************************************************************/

  /*--- Generate sendl vector ---*/

  for (i=0; i<s_L[0]; ++i) {

    if ( P0_pnum[i] == my_pnum )  {
      T0[ P0_lidx[i] ] += S0[i];  /* operator */
      ++sendl_self;
    }
    
    else
      ++sendl[P0_pnum[i]];
  }


/******************************************************************************
 *  Function : nlc_comp_mesg();                                               *
 ******************************************************************************/

  /*----------------------- setup sendl & send_offset ------------------------*/

  preprocessing_comm_(sendl,recvl,send_offset,recv_offset,
		      &tot_sendl,&tot_recvl);

  sendB = (Buffer_Type *) malloc(tot_sendl*sizeof(Buffer_Type));
  recvB = (Buffer_Type *) malloc(tot_recvl*sizeof(Buffer_Type));

  if ( (tot_sendl > 0 && sendB == NULL) || (tot_recvl > 0 && recvB == NULL) ) {
    printf(" Out of Memory: sendB in nlc_comp_mesg_1d()\n"); 
    exit(0);
  }		

  /*----------------- [ Buffer format : pointer + datum ] --------------------*/

  for (pn=0; pn<t_tot_nproc; ++pn)
    next[pn] = send_offset[pn];

  for (i=0; i<s_L[0]; ++i) {
    pn =  P0_pnum[i];
    
    if ( pn != my_pnum ) { 
      sendB[ next[pn] ].ptr =  P0_lidx[i];   /* block-cyclically */
      sendB[ next[pn] ].data = S0[i];               
      ++ next[pn];
    } 
  }
 

/******************************************************************************
 *  Function : M_to_M_PC
 ******************************************************************************/

/***
print_buffer(sendB,'S');
***/

  m_to_m_pc(sendB,sendl,send_offset,sizeof(Buffer_Type),
	    recvB,recvl,recv_offset,0);

/***
print_buffer(recvB,'R');
***/

/******************************************************************************
 *  Function : decomp_mesg_1d()                                               *
 ******************************************************************************/

  for (i=0; i< tot_recvl; ++i) 
    T0[ recvB[i].ptr ] += recvB[i].data;  /* operator */

  free(recvB);
  free(sendB);

}

